package com.mingxue.spider.youzy;

import java.util.ArrayList;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.mingxue.spider.helper.StringUtils;
import com.mingxue.spider.utils.HttpUtils;
import com.mingxue.spider.utils.UsignUtils;

import cn.hutool.core.io.IoUtil;
import cn.hutool.core.lang.Dict;
import cn.hutool.core.util.StrUtil;

public class AbstractService {
    protected Logger logger=LoggerFactory.getLogger(getClass());
    private static String host = "https://uwf7de983aad7a717eb.youzy.cn";
    private static String accessToken;

    protected String getAccessToken() {
        return accessToken;
    }

    protected void setAccessToken(String accessToken) {
        AbstractService.accessToken = accessToken;
    }

    protected Object postBody(String api) {
        return postBody(api, null);
    }

    protected Map<String, String> buildProvinceMap() {
        List<String> lines = new ArrayList<>();
        IoUtil.readUtf8Lines(getClass().getResourceAsStream("/yzy_province.txt"), lines);
        Map<String, String> map = new LinkedHashMap<>(lines.size());
        for (int i = 1; i < lines.size(); i++) {
            String line = lines.get(i);
            if (StringUtils.isNotBlank(line)) {
                List<String> sub = StrUtil.splitTrim(line, ",");
                map.put(sub.get(2), sub.get(1));
            }
        }
        return map;
    }

    protected Object postBody(String api, Dict body) {
        String requestPath = UsignUtils.getRequestPathAndParam(api, body);
        String jsonBody = JSON.toJSONString(body);
        String usign = StringUtils.EMPTY;
        if (StringUtils.isBlank(jsonBody)) {
            usign = UsignUtils.getUsign(requestPath);
        } else {
            usign = UsignUtils.getUsign(requestPath, jsonBody);
        }
        String url = host + requestPath;
        String res = HttpUtils.postBody(url, jsonBody, usign, accessToken);
        JSONObject json = JSONObject.parseObject(res);
        if (json.getBooleanValue("isSuccess")) {
            return json.get("result");
        }
        return json;
    }

    protected String decode(String encStr) {
        return UsignUtils.getUsign(encStr);
    }
}
